#include "rcpsp.h"

using namespace std;

rcpsp::rcpsp()
{ 
  ntasques=0;
  nrecursos=0;
}

void rcpsp::initMatDist(){
 
  dist = new int* [ntasques+2];
  incompatibles = new bool* [ntasques+2];
  
  for(int i=0;i<ntasques+2;i++){
    dist[i]= new int[ntasques+2];
    incompatibles[i] = new bool[ntasques+2];  
  }
   
  for(int i=0;i<ntasques+2;i++)
    for(int j=0;j<ntasques+2;j++){
	//dist[i][j]=0;
	//dist[i][j]=-MAXINT;
	dist[i][j]=-1;
	incompatibles[i][j]=false;
    } 
}

void rcpsp::imprimir_dades()
	{
		cout << "Tasques : "<< ntasques << endl;
		for(int i=0;i<=ntasques+1;i++) {
			tasca t=tascas[i];
			cout << ">>>>>>>>>>>>>>>>>>> Tasca : " << t.getnumero() << " Duracio : " << t.getduracio() << " Successors :" << t.getsuccessors() << endl ;
			vector<int> s=t.getsucs();
			vector<int> a=t.getarcs();
			vector<int> u=t.getunitats();
			for (int j=0;j<t.getsuccessors();j++) cout <<" suc : "<<j<<" nus : "<<s[j]<<" arc : "<<a[j]<< endl;
			for (int j=0;j<nrecursos;j++) cout <<" recurs : "<<j<<" unitats : " << u[j] << endl;	
		}
		cout << "Recursos :" << nrecursos << endl;
		for (int i=0;i<nrecursos;i++) cout << ">>>>>>>>>>>>>>>>>>> Recurs : " << i<< " tamany : " << capacitat[i] << endl;
	}

void rcpsp::obtenir_dades_rcp(ifstream &f){
  
  nrecursos = 0;ntasques=0;    
  if (!f.is_open()) exit(1);    
   else {          
          string vecDades; 
          int  in,invell;        
          string tab="	";
          string esp=" ";
	  vector<int> a,b,s;
	  
          getline(f,vecDades);
          in=vecDades.find(tab);
	  if (in==string::npos) {in=vecDades.find(esp);}
          ntasques=atoi(vecDades.substr(0,in).c_str())-2;
	  
	  //cout<<vecDades.substr(0,in).c_str()<<endl;
          
	  tascas.resize(ntasques+2);                      
          while (vecDades[in+1]==' ' || vecDades[in+1]=='	') in++;
          invell=in+1;

          in=vecDades.find(tab,invell);
	  if (in==string::npos) {
	    in=vecDades.find(esp);
	    if (in==string::npos) {in=vecDades.size()-1;}
	  }
	  //cout<<vecDades.substr(invell,in-invell+1).c_str()<<endl;
	 
          nrecursos=atoi(vecDades.substr(invell,in-invell+1).c_str());
          
	  //cout<<"tasques : "<<ntasques<<endl;
	  //cout<<"recursos : "<<nrecursos<<endl;
	   
          getline(f,vecDades);
          invell=0;               
          capacitat.resize(nrecursos);               
	  
          for (int j=0;j<nrecursos;j++) {
            in=vecDades.find(tab,invell); 
	    if (in==string::npos) {
	      in=vecDades.find(esp,invell);
	      if (in==string::npos) {in=vecDades.size()-1;}
	    }
	  
	    capacitat[j]=atoi(vecDades.substr(invell,in-invell+1).c_str());        
	    //cout<<capacitat[j]<<" "<<flush;
	    //cout<<in<<" "<<invell<<" "<<(in-invell+1)<<" "<<endl<<flush;
            if (j!=nrecursos-1) {
              while ((vecDades[in+1]==' ' || vecDades[in+1]=='	') && in+1<vecDades.size()-1) in++;
              invell=in+1;
            }                    
          } 
	  
	  
	  
          for(int i=0;i<=ntasques+1;i++){
	    tasca t;
	    invell=0;
            getline(f,vecDades);
            t.putnumero(i);
            in=vecDades.find(tab,invell); 
	    if (in==string::npos) {
	      in=vecDades.find(esp,invell);
	      if (in==string::npos) {in=vecDades.size()-1;}
	    }
           t.putduracio(atoi(vecDades.substr(0,in).c_str()));
            while ((vecDades[in+1]==' ' || vecDades[in+1]=='	') && in+1<vecDades.size()-1) in++;
            invell=in+1;                         
            for (int j=0;j<nrecursos;j++) {
              //in=vecDades.find(tab,invell); if (in==string::npos) {in=vecDades.size()-1;}
	      //in=vecDades.find(tab,invell); if (in==string::npos) {in=vecDades.find(" ");}
	      in=vecDades.find(tab,invell); 
	      if (in==string::npos) {
		in=vecDades.find(esp,invell);
		if (in==string::npos) {in=vecDades.size()-1;}
	      }

              t.putunitats(atoi(vecDades.substr(invell,in-invell+1).c_str()));        
              while ((vecDades[in+1]==' ' || vecDades[in+1]=='	') && in+1<vecDades.size()-1) in++;
              invell=in+1;
            }
	    //in=vecDades.find(tab,invell); if (in==string::npos) {in=vecDades.size()-1;}
	     in=vecDades.find(tab,invell); 
	     if (in==string::npos) {
		in=vecDades.find(esp,invell);
		if (in==string::npos) {in=vecDades.size()-1;}
	      }
	    t.putsuccessors(atoi(vecDades.substr(invell,in-invell+1).c_str()));
            while ((vecDades[in+1]==' ' || vecDades[in+1]=='	') && in+1<vecDades.size()-1) in++;
            invell=in+1;
            for (int k=0;k<t.getsuccessors();k++) {
              //in=vecDades.find(tab,invell); if (in==string::npos) {in=vecDades.size()-1;}
		in=vecDades.find(tab,invell); 
		if (in==string::npos) {
		  in=vecDades.find(esp,invell);
		  if (in==string::npos) {in=vecDades.size()-1;}
		}  
		t.putsucs(atoi(vecDades.substr(invell,in-invell+1).c_str())-1);
		if (k!=t.getsuccessors()-1) {
		  while ((vecDades[in+1]==' ' || vecDades[in+1]=='	') && in+1<vecDades.size()-1) in++;
		  invell=in+1;
              }
            }   
	    for (int j=0;j<t.getsuccessors();j++) t.putarcs(t.getduracio());
	    tascas[i]=t;
	  }          
	      
	  //--------------MATRIU ADJACÈNCIES--------------------------------------------------------   
	  initMatDist();
	
	  for(int i=0;i<=ntasques+1;i++){
	    tasca t;
	    t=tascas[i];
	    s=t.getsucs();
	    b=t.getarcs();
    
	  for (int j=0;j<t.getsuccessors();j++) {
	    //cout<<s[j]<<" ";
	    //cout<<b[j]<<" "<<endl;
	    if (b[j]>=0) dist[i][s[j]]=b[j];   // A la matriu nomès agafo els positius!! 
	    }
	  }
    } 
    if (d_debug) imprimir_dades();
    
    if (d_debug) cout<<"LECTURA FETA ..."<<endl<<endl<<endl;
}

void rcpsp::obtenir_dades_sch(ifstream &f){  
  
  
  nrecursos = 0;ntasques=0;
  if (!f.is_open()) exit(1);    
   else {
	  string vecDades; 
	  int  in,invell;        
	  tasca t;
	  string tab="	";
	  string esp=" ";
	  string corxt="]";
	  vector<int> a,b,s;	  		  
	  
	  invell=0;
	  getline(f,vecDades);
          in=vecDades.find(tab); 
          ntasques=atoi(vecDades.substr(0,in).c_str());
	  invell=in+1;
	  in=vecDades.find(tab);
	  nrecursos=atoi(vecDades.substr(invell,in).c_str());
	  tascas.resize(ntasques+2); 
	  for(int i=0;i<=ntasques+1;i++){
	    tasca t;
            getline(f,vecDades);
	    t.putnumero(i);
            in=vecDades.find(tab,0);
	    in=vecDades.find(tab,in+1);
	    invell=in+1;
	    in=vecDades.find(tab,invell);if (in==string::npos) {in=vecDades.size()-1;}
	    t.putsuccessors(atoi(vecDades.substr(invell,in-invell+1).c_str())); 
	    invell=in+1;
	    for (int j=0;j<t.getsuccessors();j++) {
	      in=vecDades.find(tab,invell);
	      t.putsucs(atoi(vecDades.substr(invell,in).c_str()));
	      invell=in+1;
	    }
	    invell=in+2;
	    for (int j=0;j<t.getsuccessors();j++) {
	      in=vecDades.find(corxt,invell);
	      if (in==string::npos) {in=vecDades.size()-1;}
	      t.putarcs(atoi(vecDades.substr(invell,in).c_str()));
	      invell=in+3;
	    }
	    tascas[i]=t;
	  }
	  for(int i=0;i<=ntasques+1;i++){
	   t=tascas[i];
	   getline(f,vecDades);
	   in=vecDades.find(tab,0);
	   invell=in+1;
	   in=vecDades.find(tab,invell);
	   invell=in+1;
	   in=vecDades.find(tab,invell);
	   t.putduracio(atoi(vecDades.substr(invell,in).c_str()));
	   invell=in+1;
	   for (int j=1;j<=nrecursos;j++){
	     in=vecDades.find(tab,invell);
	     if (in==string::npos) {in=vecDades.size()-1;}
	     t.putunitats(atoi(vecDades.substr(invell,in-invell+1).c_str()));
	     invell=in+1;
	   }
	   tascas[i]=t;
	  }
	  getline(f,vecDades);
	  invell=0;
	  capacitat.resize(nrecursos);
	  for (int j=0;j<nrecursos;j++){
	    in=vecDades.find(tab,invell);
	    if (in==string::npos) {in=vecDades.size()-1;}
	    capacitat[j]=atoi(vecDades.substr(invell,in).c_str());	    
	    invell=in+1;
	  }
	//--------------MATRIU ADJACÈNCIES--------------------------------------------------------   
	initMatDist();
	
	for(int i=0;i<=ntasques+1;i++){
	  tasca t;
	  t=tascas[i];
	  s=t.getsucs();
	  b=t.getarcs();
    
	  for (int j=0;j<t.getsuccessors();j++) {
	      cout<<s[j]<<" ";
	      cout<<b[j]<<" "<<endl;
	      if (b[j]>=0) dist[i][s[j]]=b[j];
	  }
	}
   }
  if (d_debug) imprimir_dades();
}

void rcpsp::obtenir_dades_sm(ifstream &f){
  
  nrecursos = 0;ntasques=0; 
  if (!f.is_open()) exit(1);    
   else {
	  string vecDades;
	  int  in,invell,ns,d;
	  string tab="	";
	  string esp=" ";
	  vector<int> a,b,s;
	  
	  invell=0;ns=0;
	  getline(f,vecDades);
	  for(int i=1;i<=5;i++){getline(f,vecDades);}
	  //printf("\nLlargada Vector : %i\n",vecDades.size());
	  ntasques=atoi(vecDades.substr(33,vecDades.length()).c_str())-2;  
	  for (int i=1;i<=3;i++) {getline(f,vecDades);}
	  in=33;
	  invell=in;
	  in=vecDades.find(esp,in+1);
	  nrecursos=atoi(vecDades.substr(invell,in).c_str());
	  for (int i=1;i<=9;i++) {getline(f,vecDades);}
	  tascas.resize(ntasques+2);
	  for(int i=0;i<=ntasques+1;i++){
	    tasca t;
	    getline(f,vecDades);
	    t.putnumero(i);
	    vecDades=vecDades.substr(14,vecDades.length());
	    invell=0;in=0;
	    while ((vecDades[in]==' ') && in<vecDades.length()) {in++;}
	    ns=atoi(vecDades.substr(in,vecDades.length()).c_str());
	    t.putsuccessors(ns);
	    vecDades=vecDades.substr(in+1,vecDades.length());
	    in=0;invell=0;
	    while ((vecDades[in]==' ') && in<vecDades.length()) {in++;}
	    invell=in;
            in=vecDades.find(esp,invell);              // si el find no troba un espai, es a dir, troba un return.....retorna un -1 
	    if (in<invell) {in=vecDades.length();}     // NO ha trobat un successor, ha trobat un "return"
	    for (int j=0;j<t.getsuccessors();j++){
	      t.putsucs(atoi(vecDades.substr(invell,in).c_str()));
	      while ((vecDades[in]==' ') && in<vecDades.length()) {in++;}
	      invell=in;
	      in=vecDades.find(esp,invell);
	      if (in<invell) {in=vecDades.length();}
	    }
	    tascas[i]=t;
	  }
	  
	  // 2a part fitxer.....
	  
	  for (int i=1;i<=4;i++) {getline(f,vecDades);}
	  for(int i=0;i<=ntasques+1;i++){
	    tasca t;
	    t=tascas[i];
	    getline(f,vecDades);
	    vecDades = vecDades.substr(14,vecDades.length());
	    in=0;
	    while ((vecDades[in]==' ') && in<vecDades.length()) {in++;}
	    invell=in;
	    in=vecDades.find(" ",invell);
	    d=atoi(vecDades.substr(invell,in).c_str());
	    t.putduracio(d);    
	    vecDades=vecDades.substr(in,vecDades.length());
	    in=0;invell=0;	   
	    while ((vecDades[in]==' ') && in<vecDades.length()) {in++;}
	    invell=in;
            in=vecDades.find(esp,invell);              // si el find no troba un espai, es a dir, troba un return.....retorna un -1 
	    if (in<invell) {in=vecDades.length();}     // NO ha trobat un successor, ha trobat un "return"
	    for (int j=0;j<nrecursos;j++){
	      t.putunitats(atoi(vecDades.substr(invell,in).c_str()));
	      while ((vecDades[in]==' ') && in<vecDades.length()) {in++;}
	      invell=in;
	      in=vecDades.find(esp,invell);
	      if (in<invell) {in=vecDades.length();}
	    }
	    tascas[i]=t;
	  }

	  capacitat.resize(nrecursos);
	  for (int i=1;i<=3;i++) {getline(f,vecDades);}
	  getline(f,vecDades);
	  in=0;
	  while ((vecDades[in+1]==' ') && in+1<vecDades.length()-1) {in++;}
	  invell=in+1;
	  capacitat.resize(nrecursos);
	  for (int j=0;j<nrecursos;j++){
	      in=vecDades.find(" ",invell);
	      if (in<invell) {in=vecDades.length();}
	      capacitat[j]=atoi(vecDades.substr(invell,in).c_str());;
	      if (in+2<vecDades.length()){
		while ((vecDades[in+1]==' ') && in+1<vecDades.length()-1) {in++;}
	      }
	      else{
		in=vecDades.length();
	      }
	      invell=in+1;
	  }
	  
	  // Els arcs son les durades....
	  for(int i=0;i<=ntasques+1;i++) {
	    tasca t;
	    t=tascas[i];
	    for (int j=0;j<=t.getsuccessors();j++){
		t.putarcs(t.getduracio());
	    }
	    tascas[i]=t;
	  }
	  
	  //--------------MATRIU ADJACÈNCIES-------------------------------------------------------   
	  initMatDist();
	
	  for(int i=0;i<=ntasques+1;i++){
	    tasca t;
	    t=tascas[i];
	    s=t.getsucs();
	    b=t.getarcs();
    
	  for (int j=0;j<t.getsuccessors();j++) {
	    cout<<s[j]<<" ";
	    cout<<b[j]<<" "<<endl;
	    if (b[j]>=0) dist[i][s[j]]=b[j];
	    }
	  }
	  
   }  
   imprimir_dades();
}

void rcpsp::obtenir_dades_pat(ifstream &f){
  
  nrecursos = 0;ntasques=0; 
  if (!f.is_open()) exit(1);    
   else {
	  string vecDades;
	  int  in,valor,id2,id3,rec,tdur,invell,factor,aux; 
	  int  prec1,prec2,prova,nsucs;
	  bool final;
	  vector<int> s,ac,crec;
	  vector<int> a,b,ss;
	  tasca t;
	  string tab="	";
          string esp=" ";
	  
	  
	  nsucs=0;invell=0;factor=1;valor=0;aux=0;
	  getline(f,vecDades);
	  ntasques=atoi(vecDades.c_str());
	  tascas.resize(ntasques+2);  
	  getline(f,vecDades); // 9999
	  getline(f,vecDades);
	  nrecursos=atoi(vecDades.c_str());
	  capacitat.resize(nrecursos);
	  for(int i=1;i<=ntasques;i++){
	    t=tascas[i];
	    getline(f,vecDades);
	    t.putnumero(atoi(vecDades.c_str()));
	    getline(f,vecDades);
	    t.putduracio(atoi(vecDades.c_str())); 
	   for (int j=0;j<nrecursos;j++){
		getline(f,vecDades);
		aux = atoi(vecDades.c_str()); 
		t.putunitats(aux);
	   }
	   tascas[i]=t;
	  }
	  
          t=tascas[0];
	  t.putnumero(0);
	  t.putduracio(0);
	  for (int j=0;j<nrecursos;j++) t.putunitats(0);
	  tascas[0]=t;
	  
	  t=tascas[ntasques+1];
	  t.putnumero(ntasques+1);
	  t.putduracio(0);
	  for (int j=0;j<nrecursos;j++) t.putunitats(0);
	  tascas[ntasques+1]=t;  
	  
	  getline(f,vecDades); // 9999
	  
	  for (int j=0;j<nrecursos;j++){
		getline(f,vecDades);
		rec=atoi(vecDades.c_str());
		capacitat[j]=rec; 
	   }  
         // Successors del 0
	 t=tascas[0];
	 for (int k=1;k<=ntasques+1;k++){
	   t.putsucs(k); // l'1 va a tots.......
           nsucs=t.getsuccessors();
	   t.putsuccessors(nsucs+1);
	   t.putarcs(0); // amb valor 0.
	 }
	 tascas[0]=t;

	 final=false;
	 prec1=-1;prec2=-2;
	 while (!final){ 
	   getline(f,vecDades);
	   prec1=atoi(vecDades.c_str());
	   if ((prec1!=9999) && (prec1!=prec2)){
	     // si trobo la marca de fi o si les precedències son iguals...no entro
	     t=tascas[prec1];
	     getline(f,vecDades);
	     prec2=atoi(vecDades.c_str());
	     t.putsucs(prec2);
	     nsucs=t.getsuccessors();
	     t.putsuccessors(nsucs+1);
	     t.putarcs(t.getduracio());
	     tascas[prec1]=t;
	   }
	   if (prec1==9999) {final=true;}
	 } 
	 // Successors del ntasques+1
         t=tascas[ntasques+1];
	 for (int k=0;k<=ntasques;k++){
	   t.putsucs(k); // tots (inclòs el 0) van a ell.....
           nsucs=t.getsuccessors();
           t.putsuccessors(nsucs+1);   
	   t.putarcs(0); // amb valor 0.
	 }  
	 tascas[ntasques+1]=t; 
	 
	 	  //-------------- MATRIU ADJACÈNCIES--------------------------------------------------------   
	  initMatDist();
	
	  for(int i=0;i<=ntasques+1;i++){
	    tasca t;
	    t=tascas[i];
	    ss=t.getsucs();
	    b=t.getarcs();
    
	  for (int j=0;j<t.getsuccessors();j++) {
	    cout<<ss[j]<<" ";
	    cout<<b[j]<<" "<<endl;
	    if (b[j]>=0) dist[i][ss[j]]=b[j];
	    }
	  }
	 
   }
   if (d_debug) imprimir_dades();
}

vector<int>  rcpsp::obtenirdadesllista(string vecDades,int limit) { 
 // Llegir el string i retornar el un vector amb valors enters......
  vector<int> vecNumeros;
  int i;
  char *a=new char[vecDades.size()+1];
  char * pch;
  
  a[vecDades.size()]=0;
  memcpy(a,vecDades.c_str(),vecDades.size());

  //printf("\nLongitud Vector Dades : %i \n", vecDades.length());
  //printf("\nContingut Vector : %s \n",vecDades.c_str()); 
  
  vecNumeros.resize(limit); 
  pch = strtok (a,"  [w(),.]");
  i=0;
  while (pch != NULL)
  {
    //printf ("\n%s\n",pch);
    vecNumeros[i]=atoi(pch);
    //printf("VALOR VECTOR: %i\n",vecNumeros[i]);
    pch = strtok (NULL, " [w(),.]");
    i++;
  }
  return (vecNumeros);
}

void rcpsp::obtenir_dades_data(ifstream &f){

  nrecursos = 0;ntasques=0; 
  if (!f.is_open()) exit(1);    
   else {
         string vecDades;
	 vector<int> vecDigits;
	 int  in,invell,k,n,nsucs;
	 tasca t;
         string tab="	";
         string esp=" ";
	 vector<int> a,b,s;
	 
	 nsucs=0;
	 getline(f,vecDades);
	 //recursos
	 getline(f,vecDades);
	 nrecursos=atoi(vecDades.c_str());
	 capacitat.resize(nrecursos);
	 getline(f,vecDades);
	 //durada de cada recurs 
	 vecDigits = obtenirdadesllista(vecDades,nrecursos);
	 for (int k=0;k<vecDigits.size();k++) capacitat[k]= vecDigits[k];
	 
	 //tasques
	 getline(f,vecDades);
	 ntasques=atoi(vecDades.c_str());
	 tascas.resize(ntasques+2);
	 
	 // durada de cada tasca 
	 getline(f,vecDades);
	 vecDigits = obtenirdadesllista(vecDades,ntasques);
	 for(int j=1;j<=ntasques;j++){
	    t.putnumero(j);  // comença a la tasca 0....fins la 11
	    t.putduracio(vecDigits[j-1]);
	    tascas[j]=t;
	 }
	 t=tascas[0];
	 t.putnumero(0);
	 t.putduracio(0);
	 tascas[0]=t;
	 t=tascas[ntasques+1];
	 t.putnumero(ntasques+1);
	 t.putduracio(0);
	 tascas[ntasques+1]=t;
	 
	 // quant gasta cada tasca de recurs determinat 
	 for(int i=0;i<nrecursos;i++){
	   getline(f,vecDades);
	   vecDigits = obtenirdadesllista(vecDades,ntasques);
	   for(int j=1;j<=ntasques;j++){
	    t=tascas[j]; 
	    t.putunitats(vecDigits[j-1]);	    
	    tascas[j]=t;
	   }
	 t=tascas[0];
	 t.putunitats(0);
	 tascas[0]=t;
	 t=tascas[ntasques+1];
	 t.putunitats(0);
	 tascas[ntasques+1]=t;
	 }
	 // Successors i Arestes 
	 for(int k=1;k<=ntasques;k++){
	      getline(f,vecDades);
	      vecDigits = obtenirdadesllista(vecDades,ntasques);
	      t=tascas[k];
	      n=0;
	      while ((vecDigits[n]!=0) && (n<vecDigits.size())) {
		t.putsucs(vecDigits[n]);
                nsucs=t.getsuccessors();
                t.putsuccessors(nsucs+1);  		
		n++;
		t.putarcs(vecDigits[n]);
		n++;
	      } 
	      tascas[k]=t;
	 } 
         // Successors del 0
	 t=tascas[0];
	 for (int k=1;k<=ntasques+1;k++){
	   t.putsucs(k); // l'1 va a tots.......
	   nsucs=t.getsuccessors();
           t.putsuccessors(nsucs+1);  
	   t.putarcs(0); // amb valor 0.
	 }
	 tascas[0]=t;
	 
	 // Successors del ntasques+1
         t=tascas[ntasques+1];
	 for (int k=0;k<=ntasques;k++){
	   t.putsucs(k); // tots (inclòs el 0) van a ell.....
	   nsucs=t.getsuccessors();
           t.putsuccessors(nsucs+1);  
	   t.putarcs(0); // amb valor 0.
	 }
	 tascas[ntasques+1]=t;
	 convert2sch();
      } //else
   imprimir_dades();
}

void rcpsp::convert2sch()
{
   ofstream fs;
   int k,ns,d,m;
   vector<int> s,a,u;
   tasca t;
   
   fs.open("file_out.sch", ofstream::out);
   fs<<ntasques;  // número de tasques
   fs<<'\t';
   fs<<nrecursos; // número de recursos
   fs<<'\t';
   fs<<0;
   fs<<'\t';
   fs<<0;  
   fs<<'\n';
   for (int k=0;k<=ntasques+1;k++){
       fs<<k;
       fs<<'\t';
       fs<<1;
       fs<<'\t';
       t=tascas[k];
       ns=t.getsuccessors();
       fs<<ns;
       s=t.getsucs();
       a=t.getarcs();
       for (int j=0;j<t.getsuccessors();j++) fs<<'\t'<<s[j];
       for (int i=0;i<t.getsuccessors();i++) fs<<'\t'<<'['<<a[i]<<']';
       fs<<'\n';
   }
   for (int k=0;k<=ntasques+1;k++){
       fs<<k;
       fs<<'\t';
       fs<<1;
       fs<<'\t';
       t=tascas[k];
       d=t.getduracio();
       fs<<d;
       u=t.getunitats();
       for (int n=0;n<nrecursos;n++) fs<<'\t'<<u[n];
       fs<<'\n';
   }
   for (m=0;m<nrecursos-1;m++) fs<<capacitat[m]<<'\t';
   fs<<capacitat[m];
   fs<<'\n';
   fs.close();
}

void rcpsp::convert2rcp()
{
   ofstream fs;
   int k,ns,d,n,m,j;
   vector<int> s,u;
   // vector<int> a;    No posem arcs perquè en el rcp el arc és la durada.....
   tasca t;
   
   fs.open("file_out.rcp", ofstream::out);
   fs<<ntasques+2;  
   fs<<'\t';
   fs<<nrecursos;   
   fs<<'\n';
   for (m=0;m<nrecursos-1;m++) fs<<capacitat[m]<<'\t';
   fs<<capacitat[m];
   fs<<'\n';
   for (k=0;k<=ntasques+1;k++){
       t=tascas[k];
       d=t.getduracio();
       fs<<d;
       u=t.getunitats();
       for (n=0;n<nrecursos;n++) fs<<'\t'<<u[n];
       ns=t.getsuccessors();
       fs<<'\t'<<ns;
       s=t.getsucs();
       for (j=0;j<t.getsuccessors();j++) fs<<'\t'<<s[j];
       fs<<'\n';
   }
   fs.close();
}

void rcpsp::convert2pat()
{
   ofstream fs;
   int k,d,m,n,id,i,j,ns;
   vector<int> s,u;
   tasca t;
  
   ns=0;
   fs.open("file_out.pat", ofstream::out);
   fs<<' '<<' '<<ntasques<<'\n';
   fs<<9999<<'\n';
   fs<<' '<<' '<<nrecursos<<'\n';
   for (k=1;k<=ntasques;k++){
     t=tascas[k];
     id=t.getnumero();
     fs<<' '<<' '<<id<<'\n';
     d=t.getduracio();
     fs<<' '<<' '<<d<<'\n';
     u=t.getunitats();
     for (n=0;n<nrecursos;n++) fs<<' '<<' '<<u[n]<<'\n';
   }
   fs<<9999<<'\n';
   for (m=0;m<nrecursos;m++) fs<<' '<<' '<<capacitat[m]<<'\n';
   for (i=1;i<=ntasques;i++){
      t=tascas[i];
      s=t.getsucs();
      ns=t.getsuccessors();
      if (ns==0) fs<<' '<<' '<<i<<'\n'<<' '<<' '<<i<<'\n';
         else{
          for (j=0;j<t.getsuccessors();j++){
	    if (s[j]>=i) fs<<' '<<' '<<i<<'\n'<<' '<<' '<<s[j]<<'\n';
          } 
	 }
   }
   fs<<9999<<'\n';
}
void rcpsp::convert2data()
{
   ofstream fs;
   int k,ns,d,n,m,i,j;
   vector<int> s,a,u;
   tasca t;
   string tab="   ";
   
   fs.open("file_out.data", ofstream::out);
   fs<<"rcpsp_max("<<'\n';
   fs<<tab<<nrecursos<<","<<'\n';
   fs<<tab<<"[";
   for (n=0;n<nrecursos-1;n++) fs<<' '<<capacitat[n]<<",";
   fs<<' '<<capacitat[n]<<' ';
   fs<<"]"<<","<<'\n';
   fs<<tab<<ntasques<<","<<'\n';
   fs<<tab<<"[";
   for (k=1;k<=ntasques-1;k++){
       t=tascas[k];
       d=t.getduracio();
       fs<<' '<<d<<',';
   }   
   d=tascas[k].getduracio();
   fs<<' '<<d<<' ';
   fs<<"]"<<","<<'\n';
   
   fs<<tab<<"[";
   
   
   // Cas 0
   fs<<"[";
   for (k=1;k<=ntasques-1;k++){
       t=tascas[k];
       u=t.getunitats();
       fs<<' '<<u[0]<<',';
     }
   t=tascas[k];
   u=t.getunitats();
   fs<<' '<<u[0]<<' '<<']'<<','<<'\n'; 
   
   // casos mig
   for (m=1;m<nrecursos-1;m++){
     fs<<tab<<' '<<"[";
     for (k=1;k<=ntasques-1;k++){
       t=tascas[k];
       u=t.getunitats();
       fs<<' '<<u[m]<<',';
     }
     t=tascas[k];
     u=t.getunitats();
     fs<<' '<<u[m]<<' '<<']'<<','<<'\n';
   }
   
   // ultim cas 
   fs<<tab<<' '<<"[";
   for (k=1;k<=ntasques-1;k++){
    t=tascas[k];
    u=t.getunitats();
    fs<<' '<<u[m]<<',';
   }
   t=tascas[k];
   u=t.getunitats();
   fs<<' '<<u[m]<<' '<<']'<<"]"<<','<<'\n';
   
   fs<<tab<<'['; 
   
   // Successors i arcs Tasca 1
   
     t=tascas[1];
     s=t.getsucs();
     a=t.getarcs();
     //for (int j=0;j<t.getsuccessors();j++)  fs<<" suc : "<<j<<" nus : "<<s[j]<<" arc : "<<a[j]<< endl;
     ns=t.getsuccessors();
     if (ns==0) fs<<'['<<' '<<']'<<','<<endl;
     if (ns==1) fs<<'['<<' '<<'w'<<'('<<s[0]<<','<<' '<<a[0]<<')'<<' '<<']'<<','<<endl;
     if (ns>1) {
	fs<<'[';
	for (j=0;j<t.getsuccessors()-1;j++)  fs<<' '<<'w'<<'('<<s[j]<<','<<' '<<a[j]<<')'<<',';
	fs<<' '<<'w'<<'('<<s[j]<<','<<' '<<a[j]<<')'<<' '<<']'<<','<<endl;
      }
   
   // Altres Successors i arcs 
   
   for(int i=2;i<=ntasques-1;i++) {
     t=tascas[i];
     s=t.getsucs();
     a=t.getarcs();
     //for (int j=0;j<t.getsuccessors();j++)  fs<<" suc : "<<j<<" nus : "<<s[j]<<" arc : "<<a[j]<< endl;
     ns=t.getsuccessors();
     if (ns==0) fs<<tab<<' '<<'['<<' '<<']'<<','<<endl;
     if (ns==1) fs<<tab<<' '<<'['<<' '<<'w'<<'('<<s[0]<<','<<' '<<a[0]<<')'<<' '<<']'<<','<<endl;
     if (ns>1) {
	fs<<tab<<' '<<'[';
	for (j=0;j<t.getsuccessors()-1;j++)  fs<<' '<<'w'<<'('<<s[j]<<','<<' '<<a[j]<<')'<<',';
	fs<<' '<<'w'<<'('<<s[j]<<','<<' '<<a[j]<<')'<<' '<<']'<<','<<endl;
      }
   }
   
    // Ultima Tasca 
     t=tascas[ntasques];
     s=t.getsucs();
     a=t.getarcs();
     //for (int j=0;j<t.getsuccessors();j++)  fs<<" suc : "<<j<<" nus : "<<s[j]<<" arc : "<<a[j]<< endl;
     ns=t.getsuccessors();
     if (ns==0) fs<<tab<<' '<<'['<<' '<<']'<<']'<<endl;
     if (ns==1) fs<<tab<<' '<<'['<<' '<<'w'<<'('<<s[0]<<','<<' '<<a[0]<<')'<<' '<<']'<<']'<<endl;
     if (ns>1) {
	fs<<tab<<' '<<'[';
	for (j=0;j<t.getsuccessors()-1;j++)  fs<<' '<<'w'<<'('<<s[j]<<','<<' '<<a[j]<<')'<<',';
	fs<<' '<<'w'<<'('<<s[j]<<','<<' '<<a[j]<<')'<<' '<<']'<<']'<<endl;
      }   
   fs<<')'<<'.'<<endl;
}

void rcpsp::convert2sm(string nomfitxer)
{
   ofstream fs;
   int k,ns,d,m,n,sum;
   vector<int> s,a,u;  
  
   fs.open("file_out.sm", ofstream::out);
   if (d_debug) cout<<"document creat..."<<endl;
   for (k=0;k<72;k++) fs<<'*';
   fs<<endl;
   fs<<"file with basedata            :  "<<nomfitxer<<endl;
   fs<<"initial value random generator:  "<<0<<endl;
   for (k=0;k<72;k++) fs<<'*';
   fs<<endl;
   fs<<"projects                      :  "<<1<<endl;
   fs<<"jobs (incl. supersource/sink ):  "<<ntasques+2<<endl;
   //
   sum=0;
   for(int i=0;i<=ntasques+1;i++) {
     tasca t=tascas[i];
     sum=sum+t.getduracio();
   }
   fs<<"horizon                       :  "<<sum<<endl;  // Falta fer la suma de les durades 
   fs<<"RESOURCES"<<endl;
   fs<<"  - renewable                 :  "<<nrecursos<<"   R"<<endl;
   fs<<"  - nonrenewable              :  "<<0<<"   N"<<endl;  
   fs<<"  - doubly constrained        :  "<<0<<"   D"<<endl;  
   for (k=0;k<72;k++) fs<<'*';
   fs<<endl;
   fs<<"PROJECT INFORMATION:"<<endl;
   fs<<"pronr.  #jobs rel.date duedate tardcost  MPM-Time"<<endl;
   for (k=0;k<4;k++) fs<<' ';
   fs<<1;                                          
   for (k=0;k<5;k++) fs<<' ';
   fs<<ntasques;
   for (k=0;k<6;k++) fs<<' ';
   fs<<0;
   for (k=0;k<7;k++) fs<<' ';
   fs<<0;                                         
   for (k=0;k<7;k++) fs<<' ';
   fs<<0;                                         
   for (k=0;k<7;k++) fs<<' ';
   fs<<0<<endl;                                   
   for (k=0;k<72;k++) fs<<'*';
   fs<<endl;
   fs<<"PRECEDENCE RELATIONS:"<<endl;
   fs<<"jobnr.    #modes  #successors   successors"<<endl;
   for (k=0;k<ntasques+2;k++){ 
     tasca t;
     t=tascas[k];
     if(k<9) fs<<"   ";
      else   fs<<"  ";
     fs<<t.getnumero()+1;
     for (int i=0;i<8;i++) fs<<' ';
     fs<<1;
     for (int j=0;j<10;j++) fs<<' ';
     fs<<t.getsuccessors();
     for (int j=0;j<10;j++) fs<<' ';
     // Inserim el número de successors........
     s=t.getsucs();
     for (n=0;n<t.getsuccessors()-1;n++){
       if (s[n]<10) fs<<' ';
       if (t.getsuccessors()>0) fs<<s[n];
	else fs<<endl;
       for (m=0;m<2;m++) fs<<' ';
     }
     if (s[n]<10) fs<<' '; // ultim successor de la tasca.........
     if (t.getsuccessors()>0) fs<<s[n]<<endl;
      else fs<<endl;
   }
   // 2a Part......     
   for (k=0;k<72;k++) fs<<'*';
   fs<<endl;
   fs<<"REQUESTS/DURATIONS:"<<endl;
   fs<<"jobnr. mode duration  ";
   for (int j=0;j<nrecursos;j++) fs<<"R "<<j+1<<"  ";
   fs<<endl;
   for (int j=0;j<72;j++) fs<<'-';
   fs<<endl;
   for (k=0;k<ntasques+2;k++){
     tasca t;
     t=tascas[k];
     if(k<9) fs<<"  ";
      else   fs<<' ';
     fs<<t.getnumero()+1;
     for (int i=0;i<6;i++) fs<<' ';
     fs<<1;
     if (t.getduracio()>=100){
       for (int j=0;j<2;j++) fs<<' ';  
     }
     else if (t.getduracio()>=10){
       for (int j=0;j<3;j++) fs<<' ';
     }
     else if (t.getduracio()<10){
       for (int j=0;j<4;j++) fs<<' ';
     }
     fs<<t.getduracio();
     for (int j=0;j<3;j++) fs<<' ';
     u=t.getunitats();
     for (int j=0;j<nrecursos;j++){
       if (u[j]<10) fs<<"    ";
	else fs<<"   ";
       fs<<u[j];
     }
     fs<<endl;
   }
   for (k=0;k<72;k++) fs<<'*';
   fs<<endl;
   fs<<"RESOURCEAVAILABILITIES:"<<endl;
   for (int j=0;j<nrecursos;j++) fs<<"  R "<<j+1;
   fs<<endl;
   for (int j=0;j<nrecursos;j++){
     if (capacitat[j]<10) fs<<"    "<<capacitat[j];
      else fs<<"   "<<capacitat[j];
   }
   fs<<endl;
   for (k=0;k<72;k++) fs<<'*';
   fs<<endl;
}

//--FASE 2------------------------------------------------------------------------------------------------------

void rcpsp::crearED(int n){
  
  d = new int [n];
  di = new int* [n];
  //dist = new int* [ntasques+2];
  vecpred = new int* [n];
  
  for(int i=0;i<n;i++){
       di[i] = new int[n];
       vecpred[i] = new int[n];
  }
  
  for(int i=0;i<n;i++)
    for(int j=0;j<n;j++){
	di[i][j]=0;
        vecpred[i][j]=0;
  }    
    
}

int rcpsp::getntasques()
{
  return(ntasques);  
}

int rcpsp::getnrecursos()
{
  return(nrecursos);  
}

int** rcpsp::getmatdistminimes()
{
  return(di);
}

bool** rcpsp::getincompatibles()
{
  return(incompatibles);
}

vector<tasca> rcpsp::obtenirtascas(){
  return(tascas);
}

vector<int> rcpsp::obtenircapacitats(){
  return(capacitat);
}


void rcpsp::omplirMatriuDist(){
  
   ofstream fs("dist_out.txt");
    
   fs<<ntasques<<endl;
   for(int i=0;i<ntasques+2;i++){
      for(int j=0;j<ntasques+2;j++){
	fs<<dist[i][j]<<' ';
	//cout<<dist[i][j]<<' '<<flush;
      }
      fs<<endl;
    } 
    fs.close();         
}

void rcpsp::calculIncompatibilitats(){

 int max_recurs;         // capacitat màxima recurs 
 int recurs_i,recurs_j;  // capacitat recurs i i capacitat recurs j
 int k;
 
 max_recurs=0;recurs_i=0;recurs_j=0;
 for (int i=0;i<ntasques+1;i++){
    //durada_i=tascas[i].getduracio();
    for (int j=i+1;j<ntasques+2;j++){
        //durada_j=tascas[j].getduracio();
        if (di[i][j]< MAXV/2 || di[j][i]< MAXV/2)
	{
          // cout<<"incomp per precedències : "<<i<<" "<<j<<endl;
          incompatibles[i][j]=true;
          incompatibles[j][i]=true;
        }
        k=0;
        while ((k<nrecursos)&&(incompatibles[i][j]==false))
	{
	  max_recurs=capacitat[k];
	  recurs_i= tascas[i].getunitats()[k];
	  recurs_j= tascas[j].getunitats()[k];
	  if (recurs_i+recurs_j>max_recurs)
	  {
	    // cout<<"incomp per recurs "<<k<<"["<<max_recurs<<"]"<<": "<<i<<"["<<recurs_i<<"]"<<" "<<j<<"["<<recurs_j<<"]"<<endl;
	    incompatibles[i][j]=true;
	    incompatibles[j][i]=true;
	  }
	  k++;
        }
    }
  }
}

void rcpsp::mostraMatriuDistMinimes(){
     cout<<"MatriuDistàncies Minimes:"<<endl<<endl;
    for(int i=0;i<n+2;i++){
      for(int j=0;j<n+2;j++){
	cout<<di[i][j]<<' '<<flush;
      }
      cout<<endl;
    }
}


void rcpsp::mostraMatrius(){
  
   cout<<"Distàncies Minimes:"<<endl<<endl;
    for(int i=0;i<n+2;i++){
      for(int j=0;j<n+2;j++){
	cout<<di[i][j]<<' '<<flush;
      }
      cout<<endl;
    }
    
    cout<<"\n\n"<<"Valor N : "<<n<<endl<<endl;
    
    cout<<endl<<endl<<endl;
    
   cout<<"Matriu de Predecessors:"<<endl<<endl;
    for(int i=0;i<n+2;i++){
      for(int j=0;j<n+2;j++){
	cout<<vecpred[i][j]<<' '<<flush;
      }
      cout<<endl;
    }
    
    cout<<endl<<endl<<endl;
    // comento nomès per traçejar correctament
    cout<<"Matriu de Valors:"<<endl<<endl;
    for(int i=0;i<ntasques+2;i++){
      for(int j=0;j<ntasques+2;j++){
	cout<<dist[i][j]<<' '<<flush;
      }
      cout<<endl;
    }    
}

void rcpsp::fer_cami(int s, int pos, int dmax){
//funcio que passant s i actual em retorni camí 

 int  actual,fi,dist_max,anterior;
 
 dmax=0;anterior=0;dist_max=0;  
 actual=pos;
 if (d_debug) cout<<endl<<"CAMI RECONSTRUÏT : "<<s<<"-->"<<pos<<endl;
 if (d_debug) cout<<endl<<pos;
 anterior=pos;
 while (actual!=s){
    if (d_debug) cout<<"<--"<<vecpred[s][actual];
    actual=vecpred[s][actual];
    //cout<<"origen: "<<actual<<" "<<"desti: "<<anterior; 
    dist_max=dist_max+di[actual][anterior];  
    dmax++;
    anterior=actual;     
 }
 dmax=dmax+1;
 if (d_debug) cout<<endl<<endl<<"Longitud: "<<dmax<<endl;
 if (d_debug) cout<<endl<<endl<<"Distància: "<<dist_max<<endl<<endl; 
}

void rcpsp::bellmanFord(int s){
  
  int i, j;
  
  //for (i = 0; i < n; ++i) d[i] = INFINITY;
  for (i = 0; i < n+2; ++i) d[i] = MAXV/2; 

  d[s] = 0;
  for (i = 0; i < n+2-1; i++)
    for (j = 0; j <edges.size(); j++)
      if (d[edges[j].u]<MAXV/2)
	if (d[edges[j].u] + edges[j].w > d[edges[j].v] || (d[edges[j].v]>=MAXV/2)) {
	 //if (d[edges[j].u] + edges[j].w < d[edges[j].v]){
	 d[edges[j].v] = d[edges[j].u] + edges[j].w;
	 vecpred[s][edges[j].v] = edges[j].u;
	}
}

void rcpsp::ferGraf(){
  // A partir de ED generem el graf de les tasques amb predecessors
  // i successors 
  for(int i=0;i<=ntasques+1;i++) {
    tasca t=tascas[i];
    cout << "Tasca : " << t.getnumero()<<" ->";
    vector<int> s=t.getsucs();
    vector<int> a=t.getarcs();
    vector<int> u=t.getunitats();
    for (int j=0;j<t.getsuccessors();j++) cout <<s[j]<<", ";
    cout<<endl;
  } 
}
void rcpsp::mostraArestes(){
  // Mostraré el número d'arestes 
  cout<<"---------------------------------------"<<endl;
  cout<<"ARESTES : "<<endl;
  
  for(int i=0;i<edges.size();i++) {
    cout<<"origen : "<<edges[i].u<<endl;
    cout<<"destí : "<<edges[i].v<<endl;
    cout<<"pes aresta : "<<edges[i].w<<endl<<endl<<endl;
  }
}
void rcpsp::tractaGraf(){
  // A partir del graf generat (fitxer "dist.txt") apliquem el Mètode 
  // Bellman Ford.
  
  int i,j,w,dmax; 
  
  //FILE *fin = fopen("dist.txt", "r");
  FILE *fin = fopen("dist_out.txt", "r");
  fscanf(fin, "%d", &n);
  crearED(n+2);     // poso aquest índex pq les tasques son n i he de tenir en compte 
                    // la primera i la última tasca, la n+1  
  
  dmax=0;
  if (d_debug) cout<<"Nº VERTEX : "<<n<<endl<<endl;
  for (i = 0; i < n+2; ++i)
    for (j = 0; j < n+2; ++j) {
	fscanf(fin, "%d", &w);
	//if (w != 0) {
	if (w >= 0) {  // SI EL PES DE L'ARESTA ÉS NEGATIU NO AFEGEIXO L'ARESTA!!!! 
	  Edge ed;
	  ed.u=i;
	  ed.v=j;
	  ed.w=w;
	  edges.push_back(ed); 
	 }
  }
  fclose(fin);
  
  for (i = 0; i < n+2; ++i){
    bellmanFord(i);
    for (j = 0; j < n+2; ++j){
	    di[i][j]=d[j];
    }
  }
	
  if (d_debug)cout<<endl<<endl;
  if (d_debug) mostraMatrius();
  fer_cami(0,ntasques+1,dmax);
  if (d_debug) ferGraf();  
  if (d_debug) cout<<endl;
}