
#ifndef TAD_RCPSP
#define TAD_RCPSP
#include "tasca.h"
#include <iostream>
#include <string.h>
//#include <conio.h>
#include <fstream>
#include <vector>
#include <stdio.h>
#include <stdlib.h>
#include <values.h>
//#include <math.h>
#include <algorithm>
#include <limits.h>
//#define MAXV 100000
#define MAXV INT_MAX
//#define INFINITY 10000

extern int d_debug;

using namespace std;

class rcpsp
{
  
  // ARESTES 
  
  typedef struct {
	int u, v, w;
  } Edge;
  
  int n; /* the number of nodes */
  int e; /* the number of edges */
  vector<Edge> edges; 
  
  
  // MATRIUS 
  
  int *d;         /* d[i] is the minimum distance from node s to node i */
  int **di;      
                 // -> Per aconseguir aquests valors s'aplica l'algorisme que descriu el mètode
		 // del Bellman Ford. ex. Di=min(dij+Di,dij+Di)
		 
  int **vecpred; // Matriu de Predecessors -->  Ho utilitzo per reconstruir el camí
  int **dist;    // Matriu de Valors --> Nomès ho utilitzo per printar la matriu de valors 

		 
  bool **incompatibles;
  
  // TASQUES 
  
  int ntasques;  // numero de tasques
  int nrecursos; // numero de recursos
  //int **cmat;
 
  vector<int> capacitat;
  vector<tasca> tascas; 

 public:
    rcpsp();
    
    void obtenir_dades_rcp(ifstream &f);   // Fitxer .rcp
    void obtenir_dades_sch(ifstream &f);   // Fitxer .sch
    void obtenir_dades_sm(ifstream &f);    // Fitxer .sm
    void obtenir_dades_pat(ifstream &f);   // Fitxer .pat  
    void obtenir_dades_data(ifstream &f);  // Fitxer .data  
    
    void convert2rcp();
    void convert2sch();
    void convert2sm(string bufp);    
    void convert2pat();
    void convert2data();
    vector<int> obtenirdadesllista(string vecDades,int limit);
    void imprimir_dades();
    void initMatDist();
    void crearED(int n);
    int** getmatdistminimes();
    bool** getincompatibles();
    void mostraMatriuDistMinimes();
    void omplirMatriuDist();
    void calculIncompatibilitats();
    int getntasques();
    int getnrecursos();
    vector<tasca> obtenirtascas();
    vector<int> obtenircapacitats();
    void fer_cami(int s, int pos, int max);
    void mostraMatrius();
    void mostraArestes();
    void bellmanFord(int s);
    void ferGraf();
    void tractaGraf();
};

#endif

