#include "ycs_rcpsp.h"

using namespace std;

ycs_rcpsp::ycs_rcpsp()
{
}
// 
void ycs_rcpsp::setcontext(yices_context c)
{
 ctx = c;
}

yices_context ycs_rcpsp::getcontext()
{ 
  return (ctx);
}

string ycs_rcpsp::int2str(int num)
{

   char temp[65];
   string temp2;
  
    sprintf(temp,"%i",num);
  
    temp2=temp;
  
    return temp2;
 }

yices_expr ycs_rcpsp::ycs_num(int dist_min){
  
  return(yices_mk_num(this->ctx,dist_min));
}


yices_expr ycs_rcpsp::ycs_boolea(bool valor){
  
  if (valor==true) return(yices_mk_true(this->ctx));
    
  if (valor==false) return(yices_mk_false(this->ctx));
  
  // unreachable code!! :
  return(yices_mk_num(this->ctx,-1));  
   
}

yices_expr ycs_rcpsp::ycs_sum(vector<yices_expr> vectexpr){
  
  return(yices_mk_sum(this->ctx,&vectexpr[0],vectexpr.size()));
}

yices_expr ycs_rcpsp::ycs_sub(vector<yices_expr> vectexpr){
 
  return(yices_mk_sub(this->ctx,&vectexpr[0],vectexpr.size()));
}

yices_expr ycs_rcpsp::ycs_mul(vector<yices_expr> vectexpr){
  
  return(yices_mk_mul(this->ctx,&vectexpr[0],vectexpr.size()));
}

yices_expr ycs_rcpsp::ycs_ge(yices_expr e1,yices_expr e_s_j){
  
  return(yices_mk_ge(this->ctx,e1,e_s_j));
}

yices_expr ycs_rcpsp::ycs_gt(yices_expr e1,yices_expr e2){
  
  return(yices_mk_gt(this->ctx,e1,e2));
}

yices_expr ycs_rcpsp::ycs_le(yices_expr e1,yices_expr e2){
  
  return(yices_mk_le(this->ctx,e1,e2));
}

yices_expr ycs_rcpsp::ycs_lt(yices_expr e1,yices_expr e2){
  
  return(yices_mk_lt(this->ctx,e1,e2));
}

yices_expr ycs_rcpsp::ycs_ite(yices_expr e1,yices_expr e2,yices_expr e3){
  
  return(yices_mk_ite(this->ctx,e1,e2,e3));
}

yices_expr ycs_rcpsp::ycs_equal(yices_expr e1,yices_expr e2){
  
  return(yices_mk_eq(this->ctx,e1,e2));
}

yices_expr ycs_rcpsp::ycs_and(vector<yices_expr> vectexpr){
  
  // PREGUNTAR A EN MIQUEL SI ÉS CORRECTE!!!!!! 
  
  return(yices_mk_and(this->ctx,&vectexpr[0],vectexpr.size()));
}

yices_expr ycs_rcpsp::ycs_or(vector<yices_expr> vectexpr){
  
  // PREGUNTAR A EN MIQUEL SI ÉS CORRECTE!!!!!! 
  
  return(yices_mk_or(this->ctx,&vectexpr[0],vectexpr.size()));
}

yices_expr ycs_rcpsp::ycs_not(yices_expr a){
  
  return(yices_mk_not(this->ctx,a));
}

void ycs_rcpsp::ycs_mostrar(yices_expr e, string str){

 
  if (str.length()>0) cout<<str<<endl;
  yices_pp_expr(e);
  cout<<endl;
  
}

void ycs_rcpsp::crearTimeWindow(rcpsp p,yices_expr e1,int n_t){

  int es,ls,sdurades,ntasc;
  vector<yices_expr> vect_and;
  
  ntasc=p.getntasques();
  
  es=0;ls=0;sdurades=durada_tasques;
  
  if (d_debug) cout<<"\n"<< " Suma Durades del CrearTimeWindow : " << durada_tasques<<"\n";      
  
  // ES (Early Starting Time) = distmin[0][i]
  es = distmin[0][n_t];
  
  // LS (Last Starting Time) = sdurades-distmin[i][ntasc+1]
  ls = sdurades-distmin[n_t][ntasc+1];
  
  yices_expr expr1 = ycs_ge(e1,ycs_num(es));     // Si >= ES
  yices_expr expr2 = ycs_le(e1,ycs_num(ls));     // Si <= LS

  vect_and.clear();
  vect_and.push_back(expr1);
  vect_and.push_back(expr2);
  w.addConstraint(ycs_and(vect_and),0); // S'ha de complir que (Si >= ES) i (Si <= LS)

}

void ycs_rcpsp::inicialitzacions_comuns(rcpsp p, WCSP w){
  
  string nom;
  
  this->vec_tascas=p.obtenirtascas(); 
  this->distmin=p.getmatdistminimes();
  this->incompatibles=p.getincompatibles();
  this->vec_cpts=p.obtenircapacitats();
  this->w = w;
  //tasc=p.getntasques();
  this->n_tasques=p.getntasques();
  this->n_recursos=p.getnrecursos();
  printf("\nTASQUES = %d\n",n_tasques);
  
  calcular_upperbound(n_tasques,vec_tascas);
  nom="objective";
  crearVariable(nom,"int");
  yices_expr obj = mapExpVar[nom];
  w.addConstraint(ycs_ge(obj,ycs_num(0)),0);
  
  yices_expr zero = ycs_num(0);
  
  for(int i=0;i<n_tasques+2;i++)
   {                               
    nom="s_"+int2str(i);       
        
    // map de yices expressions per les variables 
    crearVariable(nom,"int");
    //mapExpVar[nom]=yices_mk_var_from_decl(this->ctx,yices_mk_var_decl(this->ctx,nom.c_str(),yices_mk_type(this->ctx,"int")));
    
    yices_expr expr_si = mapExpVar[nom];
    
    if (d_debug) cout<<"\n"<<"Restringeixo Si>=0........"<<"\n\n\n";
    // restringeixo que Si>=0 
    
    w.addConstraint(ycs_ge(expr_si,zero),0);   // --> restringim que Si >= 0 .
    
    crearTimeWindow(p,expr_si,i);
   }
  yices_expr s_n1 = mapExpVar[nom]; // nom conté s_n+1
  w.addConstraint(ycs_equal(obj,s_n1),0);
  
  if (d_debug) cout<<"\n"<<"Inicialitzacions Finalitzades........"<<"\n\n\n";
  preProces1();
}

void ycs_rcpsp::calcular_upperbound(int ntasc,vector<tasca> vec_tascas){
  
  durada_tasques = 0;
  
   // SUMA TOTAL DURADES TASQUES 
   // Necessito calcular la suma de totes les durades de totes les tasques per calcular Upper Bound
   for(int i=0;i<=ntasc+1;i++) {
     tasca t=vec_tascas[i];
     durada_tasques=durada_tasques+t.getduracio();
   }
   if (d_debug) cout << "Durada Total Tasques : " << durada_tasques << endl ;
}

void ycs_rcpsp::preProces1(){
  
  string nom;
  vector<yices_expr> vectexpr;
   
  // YICES EXPRESSION
  
  for(int i=0;i<n_tasques+2;i++)
   {
    nom="s_"+int2str(i);  
    yices_expr e_s_i = mapExpVar[nom];
    vectexpr.clear();
    vectexpr.push_back(e_s_i);
    for(int j=0;j<n_tasques+2;j++)
    {
    if (i!=j){                       // "i" i "j" no poden ser iguals...perquè és la diagonal de la matriu i aquests no cal tenir-los en compte.
     if (distmin[i][j]<INT_MAX/2){   //  La distància ha de ser diferent que INT_MAX/2 com a minim. 
      nom="s_"+int2str(j);
      yices_expr e_s_j = mapExpVar[nom];
 
      yices_expr n1 = ycs_num(distmin[i][j]);
                                               
      vectexpr.push_back(n1);
     
      yices_expr e1 = ycs_sum(vectexpr);
      //yices_expr e2 = ycs_ge(e1,e_s_j);  // e1>=e_s_j --> old...
      yices_expr e2 = ycs_ge(e_s_j,e1);    // e_s_j>=e1
      w.addConstraint(e2,0);
      vectexpr.pop_back();
      }
     }
    } 
   }
}

// class ExprY1 : public Expr HERENCIA!!!!

void ycs_rcpsp::crearVariable(string nom,string tipus){
  
//   antiga definició -->  mapDeclVar[nom]=yices_mk_var_decl(this->ctx,nom.c_str(),yices_mk_type(this->ctx,"int"));
  
  
  yices_var_decl nom_var_decl=yices_mk_var_decl(this->ctx,nom.c_str(),yices_mk_type(this->ctx,tipus.c_str()));
  
  mapDeclVar[nom]=nom_var_decl;

  mapExpVar[nom]=yices_mk_var_from_decl(this->ctx,nom_var_decl);
  
  mapVarType[nom]= tipus; 
    
}

void ycs_rcpsp::afegirConstraint(yices_expr e1, int p){
  
  w.addConstraint(e1,p);
  
}

void ycs_rcpsp::codificacioTime(){
  
  //int ntasc,nrecursos;
  int sdurades;
  int min,falta;
  vector<yices_expr> vectexpr;
  vector<yices_expr> vectexpr2;
  //vector<int> vec_cpts;              // vector de capacitats dels recursos
  string nom;
  string tipus;
  
  // Calculo Horitzó : Horitzó = Suma de les durades positives 
  
  min=0;falta=0;
  sdurades=0;
  for(int i=0;i<=n_tasques+1;i++){
    tasca t=vec_tascas[i];
    sdurades=sdurades+t.getduracio();
    //cout<<"\n"<<" i "<<i<<" Durada : "<<t.getduracio()<<"\n";
  }


// ------------------------------PER DEBUGAR-----------------------------------------------------------------
  if (d_debug) {
  cout<<"\n"<< " Suma Durades : " << sdurades<<"\n"; 
 
  //-------------------------------------------------------------------------------------
  
  // MOSTRO MATRIU DISTÀNCIES MÍNIMES PER VEURE SI HI HA EL QUE HI HA D'HAVER
  
  cout<<"\n"<< " 1ª FILA : "<<"\n";
//  Mostrar Matriu Distàncies Mínimes 
   for(int i=0;i<=n_tasques+1;i++){
       cout<<distmin[0][i]<<' '<<flush;
//        quan surt la i val 30 en el nostre cas......
    }
  
  cout<<"\n"<< " 1ª COLUMNA : "<<"\n";
  
  for(int i=0;i<=n_tasques+1;i++){
      cout<<distmin[i][n_tasques+1]<<' '<<flush;
      cout<<endl;
    }
  
  
  cout<<"\n"<<"Valor ntasc:  "<<n_tasques<<"\n";
 
  //-------------------------------------------------------------------------------------
  } // fi if del (d_debug) que mostrarà la fila i colmunna
// -----------------------------------------------------------------------------------------------  
  
  
  // RESTRICCIÓ DE TEMPS INICI
  
  yices_expr zero = ycs_num(0);
  yices_expr un = ycs_num(1);
  
  // ignorem la inicial i la final (0 i ntasques+1) 
  for(int i=1;i<=n_tasques;i++){
      tasca t=vec_tascas[i];
      // distmin[0][i] = ES (Early Starting Time) 
      min = distmin[0][i];
      // sdurades-distmin[i][ntasc+1] = LS (Last Starting Time)
      falta = sdurades-distmin[i][n_tasques+1]+vec_tascas[i].getduracio()-1;
      
      // per cada tasca mirem si el seu temps inici tasca (Si=temps inici tasca)
       nom="s_"+int2str(i);  
       yices_expr e_s_i = mapExpVar[nom];
       //cout<<nom<<" "<<min<<" "<<falta<<endl;
       for(int j=min;j<=falta;j++)
       {
	  nom="ty_"+int2str(i)+"_"+int2str(j);
	  crearVariable(nom,"bool");
	  yices_expr t_bool = mapExpVar[nom];
	  
	  nom="t_"+int2str(i)+"_"+int2str(j);
	  crearVariable(nom,"int");
	  yices_expr t_int = mapExpVar[nom];
	  
	  w.addConstraint(ycs_ge(t_int,zero),0);  // t_int>=0
	  w.addConstraint(ycs_le(t_int,un),0);   // t_int<=1
	  
	  yices_expr b1 = ycs_equal(t_int,un);   // t_int = 1 
	  yices_expr b2 = ycs_equal(t_int,zero); // t_int = 0
	  w.addConstraint(ycs_ite(t_bool,b1,b2),0);
   
.	  
	  
	   yices_expr nexpr = ycs_num(j - t.getduracio());
	  
	   // ycs_gt(e_s_i,nexpr)     // e_s_i>t-pi --> nexpr = t-pi
	   
	   yices_expr restric1 = ycs_gt(e_s_i,nexpr);  // yices_expr de la restricció 1) --> e_s_i>t-pi
	   
	   yices_expr expr_t = ycs_num(j);  // passo a yices_expr de ES a FALTA (que és la j) per poder fer la restricció 1. La j és la meva "t" de les restriccions!!!!! 
	   
	   yices_expr restric2 = ycs_le(e_s_i,expr_t);      // yices_expr de la restricció 2) --> Si<=t (aqui la t és la j pq va de ES a LS+pi que és FALTA)        
           vectexpr.clear();
	   vectexpr.push_back(restric1);
	   vectexpr.push_back(restric2);
           yices_expr restric_total =ycs_and(vectexpr);                  // aqui he de fer la AND de restricció 1 i restricció 2  
	   w.addConstraint(ycs_ite(restric_total,t_bool,ycs_not(t_bool)),0);  // s'ha de fer el not meu com el ycs_num
       }   
  }
         	   
   // PER CADA RECURS.......
   for (int i=0;i<n_recursos;i++){
   if (d_debug) cout << ">>>>>>>>>>>>>>>>>>> Recurs : " << i<< " tamany : " << vec_cpts[i] << endl;
      // PER TOTA LA DURADA DE TEMPS : UPPER BOUND 
      for (int j=0;j<durada_tasques;j++){
	//cout << "Durada Tasques : " << j << endl;
	//PER TOTES LES TASQUES.......
	vectexpr2.clear();
	yices_expr t_int;
	for(int k=1;k<=n_tasques;k++) {
	  vectexpr.clear();
 	  tasca t=vec_tascas[k];
	  
	  // distmin[0][i] = ES (Early Starting Time) 
 	  min = distmin[0][k];
           // sdurades-distmin[i][ntasc+1] = LS (Last Starting Time)
          falta = sdurades-distmin[k][n_tasques+1]+vec_tascas[k].getduracio()-1;
	  
	  if ((j>=min)&&(j<=falta)){
	  
	    nom="t_"+int2str(k)+"_"+int2str(j);
	    t_int = mapExpVar[nom];

 	    vector<int> u=t.getunitats(); 	  
 	    vectexpr.push_back(ycs_num(u[i]));         // (u[i]*t_int);
 	    vectexpr.push_back(t_int);
	    vectexpr2.push_back(ycs_mul(vectexpr)); // Si està entre min i falta multipliquem per capacitat del recurs...sinó serà 0 el que sumarem...a la formula pq no fem res....
  
	  }
	}
	nom="aux_r_"+int2str(i)+"_"+int2str(j);
	crearVariable(nom,"int");
	yices_expr sum_rec=mapExpVar[nom];
	yices_expr sumatori = ycs_sum(vectexpr2);
	yices_expr equ_s = ycs_equal(sumatori,sum_rec);
	w.addConstraint(equ_s,0);
	yices_expr capacitat_max = ycs_num(vec_cpts[i]); 
 	yices_expr le_sumatori = ycs_le(sum_rec,capacitat_max);    // 	sumatori <= capacitat recurs[i]; --> del vector de capacitats;
	w.addConstraint(le_sumatori,0);	
      }
  }
  //cout<<"surto de la segona"<<endl;
}

void ycs_rcpsp::codificacioTask(){
  
  // incompatibles[i][j]  : matriu incompatibilitats 
  // distmin [i][j]       : matriu distàncies 
  
  string nom;
  vector<yices_expr> vectexpr;
  vector<yices_expr> vectexpr2;
  vector<yices_expr> vectexpr_mult;
  vector<yices_expr> vectexpr_sum;
  yices_expr sumatori;
  int resta;
  
  
  yices_expr cert = ycs_boolea(true);
  yices_expr fals = ycs_boolea(false);
  for(int i=0;i<n_tasques+1;i++)
  {
   for(int j=i+1;j<n_tasques+2;j++)
    {
     vectexpr.clear();
     nom="z1_"+int2str(i)+"_"+int2str(j); 
     crearVariable(nom,"bool");
     yices_expr expr_z1_i= mapExpVar[nom];
     
     nom="z1_"+int2str(j)+"_"+int2str(i); 
     crearVariable(nom,"bool");
     yices_expr expr_z1_j= mapExpVar[nom];

     nom="z2_"+int2str(i)+"_"+int2str(j); 
     crearVariable(nom,"bool");
     yices_expr expr_z2_i= mapExpVar[nom];
     
     nom="z2_"+int2str(j)+"_"+int2str(i); 
     crearVariable(nom,"bool");
     yices_expr expr_z2_j= mapExpVar[nom];
     
     if (distmin[i][j]<MAXV/2)    // si passa això és que hi ha camí i per tant, posem una a true i l'altre a false
      {
       w.addConstraint(ycs_equal(expr_z1_i,cert),0);    // --> restringim que z^1(i,j) = true .
       w.addConstraint(ycs_equal(expr_z1_j,fals),0);    // --> restringim que z^1(j,i) = false .
       
       w.addConstraint(ycs_equal(expr_z2_i,fals),0);    // --> restringim que z^2(i,j) = false .
       w.addConstraint(ycs_equal(expr_z2_j,cert),0);    // --> restringim que z^2(j,i) = true .
      }
      else if (distmin[j][i]<MAXV/2)   // vol dir que a distmin[i][j]==infinit i no hi ha camí.......miro si hi ha camí per el [j][i]
       {
	w.addConstraint(ycs_equal(expr_z1_i,fals),0);   // --> restringim que z^1(i,j) = true .
        w.addConstraint(ycs_equal(expr_z1_j,cert),0);   // --> restringim que z^1(j,i) = false .   
	
        w.addConstraint(ycs_equal(expr_z2_i,cert),0);   // --> restringim que z^2(i,j) = false .
        w.addConstraint(ycs_equal(expr_z2_j,fals),0);   // --> restringim que z^2(j,i) = true . 
	
       }
      else if (distmin[j][i]>=MAXV/2) // vol dir que a distmin[i][j]==infinit i no hi ha camí.......miro si hi ha camí per el [j][i]
       {
	 // Busco la S_i al vector d'expressions...
	 nom="s_"+int2str(i);       
         yices_expr expr_si = mapExpVar[nom];
	
	 // Busco la S_j al vector d'expressions...
	 nom="s_"+int2str(j);
         yices_expr expr_sj = mapExpVar[nom];
	
	 // part de z1_i_j de la task formulation
         w.addConstraint(ycs_equal(expr_z1_i,ycs_le(expr_si,expr_sj)),0);
	 w.addConstraint(ycs_equal(expr_z1_j,ycs_le(expr_sj,expr_si)),0);
	 
	 // part de z2_i_j de la task formulation
	 tasca t=vec_tascas[i];
	 tasca t2=vec_tascas[j];
	 
         yices_expr expr_durada = ycs_num(t.getduracio());
	 yices_expr expr_durada2 = ycs_num(t2.getduracio());
	 // sumo expr_si i expr_durada 
	 vectexpr.push_back(expr_si);
	 vectexpr.push_back(expr_durada);
	 yices_expr expr_distancia = ycs_sum(vectexpr);

	 w.addConstraint(ycs_equal(expr_z2_i,ycs_lt(expr_sj,expr_distancia)),0);
	 
	 vectexpr.clear();
	 vectexpr.push_back(expr_sj);
	 vectexpr.push_back(expr_durada2);
	 expr_distancia = ycs_sum(vectexpr);
	 
	  w.addConstraint(ycs_equal(expr_z2_j,ycs_lt(expr_si,expr_distancia)),0);
       }
      }
    }    
    
  
   
   for (int i=0;i<=n_tasques+1;i++)   
   {
    for (int j=0;j<=n_tasques+1;j++)  
     {
      if (i!=j)
      {
	vectexpr2.clear();
	nom="z_"+int2str(i)+"_"+int2str(j); 
	crearVariable(nom,"int");
	yices_expr expr_z_i= mapExpVar[nom];
	
	if (incompatibles[i][j]==true){
	  w.addConstraint(ycs_equal(expr_z_i,ycs_num(0)),0);  
	  nom="z1_"+int2str(i)+"_"+int2str(j);
	  yices_expr expr_z1 = mapExpVar[nom];	      
	  nom="z2_"+int2str(i)+"_"+int2str(j);
	  yices_expr expr_z2 = mapExpVar[nom];      
	  vectexpr2.push_back(expr_z1);
	  vectexpr2.push_back(expr_z2); 
	  yices_expr b = ycs_and(vectexpr2);
	  w.addConstraint(ycs_not(b),0);     // o z1 o z2 han de ser fals, no es pot complir la and dels dos pq son incompatibles
	}
	 else{
	  
	  nom="z1_"+int2str(i)+"_"+int2str(j);
	  yices_expr expr_z1 = mapExpVar[nom];	      
	  nom="z2_"+int2str(i)+"_"+int2str(j);
	  yices_expr expr_z2 = mapExpVar[nom];      
	  vectexpr2.push_back(expr_z1);
	  vectexpr2.push_back(expr_z2); 
	  yices_expr b = ycs_and(vectexpr2);
	  yices_expr b1 = ycs_equal(expr_z_i,ycs_num(1));   // z_i_j=1
	  yices_expr b2 = ycs_equal(expr_z_i,ycs_num(0));   // z_i_j=0		
	  w.addConstraint(ycs_ite(b,b1,b2),0);
	    }
       }
     }
   } 
   
   for (int j=0;j<=n_tasques+1;j++)
   {
    tasca t = vec_tascas[j];
    vector<int> u=t.getunitats();
    resta=0;
    for (int k=0;k<n_recursos;k++)
    {
      vectexpr_sum.clear();
      resta = (vec_cpts[k] - u[k]);
      //cout<<vec_cpts[k]<<" "<<u[k]<<endl;
      
      for (int i=0;i<=n_tasques+1;i++)
      {
       if (i!=j)
       {
	vectexpr_mult.clear();
	tasca t2 = vec_tascas[i]; 
	vector<int> v=t2.getunitats(); 	  
	
	if (v[k]>0)
	{
	    // SUMATORI
	  vectexpr_mult.push_back(ycs_num(v[k]));         // preparo multiplicació : b_i,k
	  
	  nom="z_"+int2str(i)+"_"+int2str(j);
	  yices_expr expr_z_i_j= mapExpVar[nom];
	  vectexpr_mult.push_back(expr_z_i_j);            // preparo multiplicació : z_i,k
		                                          // sumatori de la multiplicació (b_i,k * z_i,k) 
	  vectexpr_sum.push_back(ycs_mul(vectexpr_mult)); // multiplicació (b_i,k * z_i,k) i ho poso al vector per fer suma
	}
       }
      }
      // EXPRESSIÓ : (Sumatori <=  RESTA Bk-bj,k)
          
      // yices_expr expressio = ycs_le(sumatori,ycs_sub(vectexpr_sub));
      if (vectexpr_sum.size()>0)
      {
	if (vectexpr_sum.size()==1) sumatori = vectexpr_sum[0];
	 else sumatori = ycs_sum(vectexpr_sum);
	w.addConstraint(ycs_le(sumatori,ycs_num(resta)),0);
      }
     }   
   }    
}

void ycs_rcpsp::solucionar(bool model){
  
 w.solve(model,0,durada_tasques,mapDeclVar);
}

long ycs_rcpsp::buscaValor(yices_model m, string val_str, yices_var_decl vardcl){
  
  string typ_var;
  lbool val_bool;      // valor booleà de la variable boolena t_bool
  long val;
  
      
    typ_var = mapVarType[val_str];
    
    // consulto el tipus en el mapVarType i si és int cridaré la funció yices_get_int_value i si és bool cridaré yices_get_value
    // que retorna un bool 
    if (typ_var == "int") yices_get_int_value(m,vardcl,&val);
    else if (typ_var == "bool"){
      val_bool= yices_get_value(m,vardcl);
      
      if (val_bool==l_true) val=1;
      else if (val_bool==l_false) val=0;
      else if (val_bool==l_undef) val=-1;
    }
  return val;
}

void ycs_rcpsp::recupera(){

  yices_model m = yices_get_model(ctx);
 
  std::map<string,yices_var_decl>::iterator it = mapDeclVar.begin();
  
  for (it=mapDeclVar.begin(); it!=mapDeclVar.end(); ++it)  mapVarVal[it->first]= buscaValor(m,it->first,it->second);
}

void ycs_rcpsp::mostraResultats(){
  
  string nom;
  int i;

  cout<<"Valor de les Si : "<<endl;
  cout<<"S = [";
  for(i=0;i<n_tasques+1;i++){
    nom="s_"+int2str(i); 
    cout<<mapVarVal[nom]<<","; 
  }
  nom="s_"+int2str(i); 
  cout<<mapVarVal[nom]<<"]"<<endl;
}


void ycs_rcpsp::delcontext(){
  yices_del_context(ctx);
}







